[**@rxap/data-source v19.0.2**](../README.md)

***

[@rxap/data-source](../globals.md) / ObservableDataSource

# Class: ObservableDataSource\<Data\>

Defined in: [packages/angular/data-source/src/lib/observable.data-source.ts:23](https://gitlab.com/rxap/packages/-/blob/d77504e6fd71447b1032f897cabb2aefac17c260/packages/angular/data-source/src/lib/observable.data-source.ts#L23)

## Extends

- [`BaseDataSource`](BaseDataSource.md)\<`Data`, [`ObservableDataSourceMetadata`](../interfaces/ObservableDataSourceMetadata.md)\<`Data`\>\>

## Type Parameters

• **Data**

## Constructors

### new ObservableDataSource()

> **new ObservableDataSource**\<`Data`\>(`observable`, `metadata`): [`ObservableDataSource`](ObservableDataSource.md)\<`Data`\>

Defined in: [packages/angular/data-source/src/lib/observable.data-source.ts:25](https://gitlab.com/rxap/packages/-/blob/d77504e6fd71447b1032f897cabb2aefac17c260/packages/angular/data-source/src/lib/observable.data-source.ts#L25)

#### Parameters

##### observable

`null` | `Observable`\<`Data`\>

##### metadata

`null` | [`ObservableDataSourceMetadata`](../interfaces/ObservableDataSourceMetadata.md)\<`Data`\>

#### Returns

[`ObservableDataSource`](ObservableDataSource.md)\<`Data`\>

#### Overrides

[`BaseDataSource`](BaseDataSource.md).[`constructor`](BaseDataSource.md#constructors)

## Properties

### \_\_id

> **\_\_id**: `string`

Defined in: [packages/angular/definition/src/lib/definition.ts:61](https://gitlab.com/rxap/packages/-/blob/d77504e6fd71447b1032f897cabb2aefac17c260/packages/angular/definition/src/lib/definition.ts#L61)

**`Internal`**

unique internal id

#### Inherited from

[`BaseDataSource`](BaseDataSource.md).[`__id`](BaseDataSource.md#__id)

***

### \_connectedViewer

> `protected` **\_connectedViewer**: `Map`\<`string`, `Observable`\<`Data`\>\>

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:78](https://gitlab.com/rxap/packages/-/blob/d77504e6fd71447b1032f897cabb2aefac17c260/packages/angular/data-source/src/lib/base.data-source.ts#L78)

#### Inherited from

[`BaseDataSource`](BaseDataSource.md).[`_connectedViewer`](BaseDataSource.md#_connectedviewer)

***

### \_connectedViewerTeardown

> `protected` **\_connectedViewerTeardown**: `Map`\<`string`, `TeardownLogic`\>

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:79](https://gitlab.com/rxap/packages/-/blob/d77504e6fd71447b1032f897cabb2aefac17c260/packages/angular/data-source/src/lib/base.data-source.ts#L79)

#### Inherited from

[`BaseDataSource`](BaseDataSource.md).[`_connectedViewerTeardown`](BaseDataSource.md#_connectedviewerteardown)

***

### \_data?

> `protected` `optional` **\_data**: `Data`

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:104](https://gitlab.com/rxap/packages/-/blob/d77504e6fd71447b1032f897cabb2aefac17c260/packages/angular/data-source/src/lib/base.data-source.ts#L104)

#### Inherited from

[`BaseDataSource`](BaseDataSource.md).[`_data`](BaseDataSource.md#_data)

***

### \_data$

> `protected` **\_data$**: `Observable`\<`Data`\> = `EMPTY`

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:83](https://gitlab.com/rxap/packages/-/blob/d77504e6fd71447b1032f897cabb2aefac17c260/packages/angular/data-source/src/lib/base.data-source.ts#L83)

#### Inherited from

[`BaseDataSource`](BaseDataSource.md).[`_data$`](BaseDataSource.md#_data$)

***

### \_initialised

> `protected` **\_initialised**: `boolean` = `false`

Defined in: [packages/angular/definition/src/lib/definition.ts:62](https://gitlab.com/rxap/packages/-/blob/d77504e6fd71447b1032f897cabb2aefac17c260/packages/angular/definition/src/lib/definition.ts#L62)

#### Inherited from

[`BaseDataSource`](BaseDataSource.md).[`_initialised`](BaseDataSource.md#_initialised)

***

### \_lastRefreshed

> `protected` **\_lastRefreshed**: `null` \| `Date` = `null`

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:77](https://gitlab.com/rxap/packages/-/blob/d77504e6fd71447b1032f897cabb2aefac17c260/packages/angular/data-source/src/lib/base.data-source.ts#L77)

#### Inherited from

[`BaseDataSource`](BaseDataSource.md).[`_lastRefreshed`](BaseDataSource.md#_lastrefreshed)

***

### \_retry$

> `protected` **\_retry$**: `Subject`\<`void`\>

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:90](https://gitlab.com/rxap/packages/-/blob/d77504e6fd71447b1032f897cabb2aefac17c260/packages/angular/data-source/src/lib/base.data-source.ts#L90)

#### Inherited from

[`BaseDataSource`](BaseDataSource.md).[`_retry$`](BaseDataSource.md#_retry$)

***

### \_viewerIds

> `protected` **\_viewerIds**: `Map`\<[`BaseDataSourceViewer`](../interfaces/BaseDataSourceViewer.md)\<`any`\>, `string`\>

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:89](https://gitlab.com/rxap/packages/-/blob/d77504e6fd71447b1032f897cabb2aefac17c260/packages/angular/data-source/src/lib/base.data-source.ts#L89)

a map of viewer to view id.
Allows to create a view id from the viewer object reference

#### Inherited from

[`BaseDataSource`](BaseDataSource.md).[`_viewerIds`](BaseDataSource.md#_viewerids)

***

### change$

> `readonly` **change$**: `Subject`\<`Data`\>

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:67](https://gitlab.com/rxap/packages/-/blob/d77504e6fd71447b1032f897cabb2aefac17c260/packages/angular/data-source/src/lib/base.data-source.ts#L67)

#### Inherited from

[`BaseDataSource`](BaseDataSource.md).[`change$`](BaseDataSource.md#change$)

***

### destroyed$

> `readonly` **destroyed$**: `undefined` \| `Subject`\<`void`\>

Defined in: [packages/angular/definition/src/lib/definition.ts:48](https://gitlab.com/rxap/packages/-/blob/d77504e6fd71447b1032f897cabb2aefac17c260/packages/angular/definition/src/lib/definition.ts#L48)

Emits if the data source is destroyed

#### Inherited from

[`BaseDataSource`](BaseDataSource.md).[`destroyed$`](BaseDataSource.md#destroyed$)

***

### error$

> `readonly` **error$**: `ReplaySubject`\<`Error`\>

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:73](https://gitlab.com/rxap/packages/-/blob/d77504e6fd71447b1032f897cabb2aefac17c260/packages/angular/data-source/src/lib/base.data-source.ts#L73)

#### Inherited from

[`BaseDataSource`](BaseDataSource.md).[`error$`](BaseDataSource.md#error$)

***

### hasError?

> `optional` **hasError**: `Signal`\<`boolean`\>

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:94](https://gitlab.com/rxap/packages/-/blob/d77504e6fd71447b1032f897cabb2aefac17c260/packages/angular/data-source/src/lib/base.data-source.ts#L94)

#### Inherited from

[`BaseDataSource`](BaseDataSource.md).[`hasError`](BaseDataSource.md#haserror)

***

### hasError$

> `readonly` **hasError$**: `ToggleSubject`

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:72](https://gitlab.com/rxap/packages/-/blob/d77504e6fd71447b1032f897cabb2aefac17c260/packages/angular/data-source/src/lib/base.data-source.ts#L72)

#### Inherited from

[`BaseDataSource`](BaseDataSource.md).[`hasError$`](BaseDataSource.md#haserror$)

***

### initialised$

> `readonly` **initialised$**: `undefined` \| `Subject`\<`void`\>

Defined in: [packages/angular/definition/src/lib/definition.ts:52](https://gitlab.com/rxap/packages/-/blob/d77504e6fd71447b1032f897cabb2aefac17c260/packages/angular/definition/src/lib/definition.ts#L52)

Emits if the data source is initialised

#### Inherited from

[`BaseDataSource`](BaseDataSource.md).[`initialised$`](BaseDataSource.md#initialised$)

***

### interceptors

> `readonly` **interceptors**: `undefined` \| `Set`\<`Subject`\<`any`\>\>

Defined in: [packages/angular/definition/src/lib/definition.ts:53](https://gitlab.com/rxap/packages/-/blob/d77504e6fd71447b1032f897cabb2aefac17c260/packages/angular/definition/src/lib/definition.ts#L53)

#### Inherited from

[`BaseDataSource`](BaseDataSource.md).[`interceptors`](BaseDataSource.md#interceptors)

***

### loading?

> `optional` **loading**: `Signal`\<`boolean`\>

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:92](https://gitlab.com/rxap/packages/-/blob/d77504e6fd71447b1032f897cabb2aefac17c260/packages/angular/data-source/src/lib/base.data-source.ts#L92)

#### Inherited from

[`BaseDataSource`](BaseDataSource.md).[`loading`](BaseDataSource.md#loading)

***

### loading$

> **loading$**: `Observable`\<`boolean`\> = `EMPTY`

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:71](https://gitlab.com/rxap/packages/-/blob/d77504e6fd71447b1032f897cabb2aefac17c260/packages/angular/data-source/src/lib/base.data-source.ts#L71)

Indicates weather the data source is currently loading new data

#### Inherited from

[`BaseDataSource`](BaseDataSource.md).[`loading$`](BaseDataSource.md#loading$)

***

### metadata

> **metadata**: [`ObservableDataSourceMetadata`](../interfaces/ObservableDataSourceMetadata.md)

Defined in: [packages/angular/definition/src/lib/definition.ts:44](https://gitlab.com/rxap/packages/-/blob/d77504e6fd71447b1032f897cabb2aefac17c260/packages/angular/definition/src/lib/definition.ts#L44)

#### Inherited from

[`BaseDataSource`](BaseDataSource.md).[`metadata`](BaseDataSource.md#metadata-1)

***

### destroyed$

> `readonly` `static` **destroyed$**: `Subject`\<`BaseDefinition`\<`BaseDefinitionMetadata`\>\>

Defined in: [packages/angular/definition/src/lib/definition.ts:41](https://gitlab.com/rxap/packages/-/blob/d77504e6fd71447b1032f897cabb2aefac17c260/packages/angular/definition/src/lib/definition.ts#L41)

Emits when a new Definition instance is initialised

#### Inherited from

[`BaseDataSource`](BaseDataSource.md).[`destroyed$`](BaseDataSource.md#destroyed$-1)

***

### initialised$

> `readonly` `static` **initialised$**: `Subject`\<`BaseDefinition`\<`BaseDefinitionMetadata`\>\>

Defined in: [packages/angular/definition/src/lib/definition.ts:35](https://gitlab.com/rxap/packages/-/blob/d77504e6fd71447b1032f897cabb2aefac17c260/packages/angular/definition/src/lib/definition.ts#L35)

Emits when a new Definition instance is initialised

#### Inherited from

[`BaseDataSource`](BaseDataSource.md).[`initialised$`](BaseDataSource.md#initialised$-1)

***

### instances

> `readonly` `static` **instances**: `Map`\<`string`, `BaseDefinition`\<`BaseDefinitionMetadata`\>\>

Defined in: [packages/angular/definition/src/lib/definition.ts:27](https://gitlab.com/rxap/packages/-/blob/d77504e6fd71447b1032f897cabb2aefac17c260/packages/angular/definition/src/lib/definition.ts#L27)

A map of active Definition instances

#### Inherited from

[`BaseDataSource`](BaseDataSource.md).[`instances`](BaseDataSource.md#instances)

## Accessors

### data

#### Get Signature

> **get** **data**(): `undefined` \| `Data`

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:106](https://gitlab.com/rxap/packages/-/blob/d77504e6fd71447b1032f897cabb2aefac17c260/packages/angular/data-source/src/lib/base.data-source.ts#L106)

##### Returns

`undefined` \| `Data`

#### Inherited from

[`BaseDataSource`](BaseDataSource.md).[`data`](BaseDataSource.md#data)

***

### hasConnections

#### Get Signature

> **get** **hasConnections**(): `boolean`

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:110](https://gitlab.com/rxap/packages/-/blob/d77504e6fd71447b1032f897cabb2aefac17c260/packages/angular/data-source/src/lib/base.data-source.ts#L110)

##### Returns

`boolean`

#### Inherited from

[`BaseDataSource`](BaseDataSource.md).[`hasConnections`](BaseDataSource.md#hasconnections)

***

### id

#### Get Signature

> **get** **id**(): `string`

Defined in: [packages/angular/definition/src/lib/definition.ts:87](https://gitlab.com/rxap/packages/-/blob/d77504e6fd71447b1032f897cabb2aefac17c260/packages/angular/definition/src/lib/definition.ts#L87)

##### Returns

`string`

#### Inherited from

[`BaseDataSource`](BaseDataSource.md).[`id`](BaseDataSource.md#id)

***

### lastRefreshed

#### Get Signature

> **get** **lastRefreshed**(): `null` \| `Date`

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:74](https://gitlab.com/rxap/packages/-/blob/d77504e6fd71447b1032f897cabb2aefac17c260/packages/angular/data-source/src/lib/base.data-source.ts#L74)

##### Returns

`null` \| `Date`

#### Inherited from

[`BaseDataSource`](BaseDataSource.md).[`lastRefreshed`](BaseDataSource.md#lastrefreshed)

## Methods

### \_connect()

> `protected` **\_connect**(`viewer`): `Observable`\<`Data`\> \| \[`Observable`\<`Data`\>, `TeardownLogic`\]

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:323](https://gitlab.com/rxap/packages/-/blob/d77504e6fd71447b1032f897cabb2aefac17c260/packages/angular/data-source/src/lib/base.data-source.ts#L323)

#### Parameters

##### viewer

[`BaseDataSourceViewer`](../interfaces/BaseDataSourceViewer.md)

#### Returns

`Observable`\<`Data`\> \| \[`Observable`\<`Data`\>, `TeardownLogic`\]

#### Inherited from

[`BaseDataSource`](BaseDataSource.md).[`_connect`](BaseDataSource.md#_connect)

***

### \_disconnect()

> `protected` **\_disconnect**(`viewerId`): `void`

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:308](https://gitlab.com/rxap/packages/-/blob/d77504e6fd71447b1032f897cabb2aefac17c260/packages/angular/data-source/src/lib/base.data-source.ts#L308)

#### Parameters

##### viewerId

`string`

#### Returns

`void`

#### Inherited from

[`BaseDataSource`](BaseDataSource.md).[`_disconnect`](BaseDataSource.md#_disconnect)

***

### applyMetadata()

> **applyMetadata**(`partialMetadata`): `void`

Defined in: [packages/angular/definition/src/lib/definition.ts:111](https://gitlab.com/rxap/packages/-/blob/d77504e6fd71447b1032f897cabb2aefac17c260/packages/angular/definition/src/lib/definition.ts#L111)

#### Parameters

##### partialMetadata

`Partial`\<[`ObservableDataSourceMetadata`](../interfaces/ObservableDataSourceMetadata.md)\<`Data`\>\>

#### Returns

`void`

#### Inherited from

[`BaseDataSource`](BaseDataSource.md).[`applyMetadata`](BaseDataSource.md#applymetadata)

***

### attach()

> **attach**(`viewerId`): `Observable`\<`Data`\>

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:210](https://gitlab.com/rxap/packages/-/blob/d77504e6fd71447b1032f897cabb2aefac17c260/packages/angular/data-source/src/lib/base.data-source.ts#L210)

#### Parameters

##### viewerId

`string`

#### Returns

`Observable`\<`Data`\>

#### Inherited from

[`BaseDataSource`](BaseDataSource.md).[`attach`](BaseDataSource.md#attach)

***

### connect()

> **connect**(`viewerOrString`): `Observable`\<`Data`\>

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:124](https://gitlab.com/rxap/packages/-/blob/d77504e6fd71447b1032f897cabb2aefac17c260/packages/angular/data-source/src/lib/base.data-source.ts#L124)

#### Parameters

##### viewerOrString

`string` | [`BaseDataSourceViewer`](../interfaces/BaseDataSourceViewer.md)\<`any`\>

#### Returns

`Observable`\<`Data`\>

#### Inherited from

[`BaseDataSource`](BaseDataSource.md).[`connect`](BaseDataSource.md#connect)

***

### derive()

> **derive**(`id`, `metadata`): [`BaseDataSource`](BaseDataSource.md)\<`any`\>

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:270](https://gitlab.com/rxap/packages/-/blob/d77504e6fd71447b1032f897cabb2aefac17c260/packages/angular/data-source/src/lib/base.data-source.ts#L270)

#### Parameters

##### id

`string`

##### metadata

`Partial`\<[`BaseDataSourceMetadata`](../interfaces/BaseDataSourceMetadata.md)\> = `...`

#### Returns

[`BaseDataSource`](BaseDataSource.md)\<`any`\>

#### Inherited from

[`BaseDataSource`](BaseDataSource.md).[`derive`](BaseDataSource.md#derive)

***

### ~~destroy()~~

> **destroy**(): `void`

Defined in: [packages/angular/definition/src/lib/definition.ts:118](https://gitlab.com/rxap/packages/-/blob/d77504e6fd71447b1032f897cabb2aefac17c260/packages/angular/definition/src/lib/definition.ts#L118)

#### Returns

`void`

#### Deprecated

use ngOnDestroy instead

#### Inherited from

[`BaseDataSource`](BaseDataSource.md).[`destroy`](BaseDataSource.md#destroy)

***

### disconnect()

> **disconnect**(`viewerOrId`): `void`

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:225](https://gitlab.com/rxap/packages/-/blob/d77504e6fd71447b1032f897cabb2aefac17c260/packages/angular/data-source/src/lib/base.data-source.ts#L225)

#### Parameters

##### viewerOrId

`string` | [`BaseDataSourceViewer`](../interfaces/BaseDataSourceViewer.md)\<`any`\>

#### Returns

`void`

#### Inherited from

[`BaseDataSource`](BaseDataSource.md).[`disconnect`](BaseDataSource.md#disconnect)

***

### genericRetryFunction()

> `protected` **genericRetryFunction**(`error`, `retryCount`): `Observable`\<`any`\>

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:311](https://gitlab.com/rxap/packages/-/blob/d77504e6fd71447b1032f897cabb2aefac17c260/packages/angular/data-source/src/lib/base.data-source.ts#L311)

#### Parameters

##### error

`any`

##### retryCount

`number`

#### Returns

`Observable`\<`any`\>

#### Inherited from

[`BaseDataSource`](BaseDataSource.md).[`genericRetryFunction`](BaseDataSource.md#genericretryfunction)

***

### getMetadata()

> **getMetadata**(): `null` \| [`ObservableDataSourceMetadata`](../interfaces/ObservableDataSourceMetadata.md)\<`Data`\>

Defined in: [packages/angular/definition/src/lib/definition.ts:107](https://gitlab.com/rxap/packages/-/blob/d77504e6fd71447b1032f897cabb2aefac17c260/packages/angular/definition/src/lib/definition.ts#L107)

#### Returns

`null` \| [`ObservableDataSourceMetadata`](../interfaces/ObservableDataSourceMetadata.md)\<`Data`\>

#### Inherited from

[`BaseDataSource`](BaseDataSource.md).[`getMetadata`](BaseDataSource.md#getmetadata)

***

### getViewerId()

> **getViewerId**(`viewer`): `string`

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:114](https://gitlab.com/rxap/packages/-/blob/d77504e6fd71447b1032f897cabb2aefac17c260/packages/angular/data-source/src/lib/base.data-source.ts#L114)

#### Parameters

##### viewer

[`BaseDataSourceViewer`](../interfaces/BaseDataSourceViewer.md)

#### Returns

`string`

#### Inherited from

[`BaseDataSource`](BaseDataSource.md).[`getViewerId`](BaseDataSource.md#getviewerid)

***

### handelError()

> `protected` **handelError**(`error`): `void`

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:317](https://gitlab.com/rxap/packages/-/blob/d77504e6fd71447b1032f897cabb2aefac17c260/packages/angular/data-source/src/lib/base.data-source.ts#L317)

#### Parameters

##### error

`any`

#### Returns

`void`

#### Inherited from

[`BaseDataSource`](BaseDataSource.md).[`handelError`](BaseDataSource.md#handelerror)

***

### init()

> **init**(): `void`

Defined in: [packages/angular/definition/src/lib/definition.ts:127](https://gitlab.com/rxap/packages/-/blob/d77504e6fd71447b1032f897cabb2aefac17c260/packages/angular/definition/src/lib/definition.ts#L127)

#### Returns

`void`

#### Inherited from

[`BaseDataSource`](BaseDataSource.md).[`init`](BaseDataSource.md#init)

***

### isConnected()

> **isConnected**(`viewerOrId`): `boolean`

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:217](https://gitlab.com/rxap/packages/-/blob/d77504e6fd71447b1032f897cabb2aefac17c260/packages/angular/data-source/src/lib/base.data-source.ts#L217)

#### Parameters

##### viewerOrId

`string` | [`BaseDataSourceViewer`](../interfaces/BaseDataSourceViewer.md)\<`any`\>

#### Returns

`boolean`

#### Inherited from

[`BaseDataSource`](BaseDataSource.md).[`isConnected`](BaseDataSource.md#isconnected)

***

### ngOnDestroy()

> **ngOnDestroy**(): `void`

Defined in: [packages/angular/definition/src/lib/definition.ts:122](https://gitlab.com/rxap/packages/-/blob/d77504e6fd71447b1032f897cabb2aefac17c260/packages/angular/definition/src/lib/definition.ts#L122)

A callback method that performs custom clean-up, invoked immediately
before a directive, pipe, or service instance is destroyed.

#### Returns

`void`

#### Inherited from

[`BaseDataSource`](BaseDataSource.md).[`ngOnDestroy`](BaseDataSource.md#ngondestroy)

***

### refresh()

> **refresh**(): `any`

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:290](https://gitlab.com/rxap/packages/-/blob/d77504e6fd71447b1032f897cabb2aefac17c260/packages/angular/data-source/src/lib/base.data-source.ts#L290)

#### Returns

`any`

#### Inherited from

[`BaseDataSource`](BaseDataSource.md).[`refresh`](BaseDataSource.md#refresh)

***

### reset()

> **reset**(): `any`

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:297](https://gitlab.com/rxap/packages/-/blob/d77504e6fd71447b1032f897cabb2aefac17c260/packages/angular/data-source/src/lib/base.data-source.ts#L297)

#### Returns

`any`

#### Inherited from

[`BaseDataSource`](BaseDataSource.md).[`reset`](BaseDataSource.md#reset)

***

### retry()

> **retry**(): `any`

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:293](https://gitlab.com/rxap/packages/-/blob/d77504e6fd71447b1032f897cabb2aefac17c260/packages/angular/data-source/src/lib/base.data-source.ts#L293)

#### Returns

`any`

#### Inherited from

[`BaseDataSource`](BaseDataSource.md).[`retry`](BaseDataSource.md#retry)

***

### toJSON()

> **toJSON**(): `object`

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:280](https://gitlab.com/rxap/packages/-/blob/d77504e6fd71447b1032f897cabb2aefac17c260/packages/angular/data-source/src/lib/base.data-source.ts#L280)

#### Returns

`object`

#### Inherited from

[`BaseDataSource`](BaseDataSource.md).[`toJSON`](BaseDataSource.md#tojson)

***

### toPromise()

> **toPromise**(`viewer`): `Promise`\<`Data`\>

Defined in: [packages/angular/data-source/src/lib/base.data-source.ts:264](https://gitlab.com/rxap/packages/-/blob/d77504e6fd71447b1032f897cabb2aefac17c260/packages/angular/data-source/src/lib/base.data-source.ts#L264)

Creates a connection to tha data source and converts the Observable into a
promise and then disconnects the viewer

#### Parameters

##### viewer

[`BaseDataSourceViewer`](../interfaces/BaseDataSourceViewer.md)

#### Returns

`Promise`\<`Data`\>

#### Inherited from

[`BaseDataSource`](BaseDataSource.md).[`toPromise`](BaseDataSource.md#topromise)

***

### add()

> `static` **add**(`definition`): `void`

Defined in: [packages/angular/definition/src/lib/definition.ts:94](https://gitlab.com/rxap/packages/-/blob/d77504e6fd71447b1032f897cabb2aefac17c260/packages/angular/definition/src/lib/definition.ts#L94)

#### Parameters

##### definition

`BaseDefinition`

#### Returns

`void`

#### Inherited from

[`BaseDataSource`](BaseDataSource.md).[`add`](BaseDataSource.md#add)

***

### remove()

> `static` **remove**(`definition`): `void`

Defined in: [packages/angular/definition/src/lib/definition.ts:102](https://gitlab.com/rxap/packages/-/blob/d77504e6fd71447b1032f897cabb2aefac17c260/packages/angular/definition/src/lib/definition.ts#L102)

#### Parameters

##### definition

`BaseDefinition`

#### Returns

`void`

#### Inherited from

[`BaseDataSource`](BaseDataSource.md).[`remove`](BaseDataSource.md#remove)
